> ## Documentation Index
> Fetch the complete documentation index at: https://developers.circle.com/llms.txt
> Use this file to discover all available pages before exploring further.

# List challenges

> List all challenges by status for a user.



## OpenAPI

````yaml openapi/user-controlled-wallets.yaml get /v1/w3s/user/challenges
openapi: 3.0.3
info:
  version: '1.0'
  title: User-Controlled Wallets
  description: User-Controlled Wallets API documentation.
servers:
  - url: https://api.circle.com
security:
  - BearerAuth: []
tags:
  - name: Social/ Email Authentication
  - name: PIN Authentication
  - name: Users
  - name: Wallets
  - name: Transactions
  - name: Token Lookup
  - name: Signing
paths:
  /v1/w3s/user/challenges:
    get:
      tags:
        - Users
      summary: List challenges
      description: List all challenges by status for a user.
      operationId: listUserChallenges
      parameters:
        - $ref: '#/components/parameters/XUserToken'
        - $ref: '#/components/parameters/Status'
        - $ref: '#/components/parameters/XRequestId'
      responses:
        '200':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Challenges'
          description: Successfully retrieved the challenges.
          headers:
            X-Request-Id:
              $ref: '#/components/headers/XRequestId'
        '400':
          $ref: '#/components/responses/BadRequest'
        '401':
          $ref: '#/components/responses/NotAuthorized'
        '404':
          $ref: '#/components/responses/NotFound'
      security:
        - BearerAuth: []
components:
  parameters:
    XUserToken:
      name: X-User-Token
      description: Unique system generated JWT session token for specific user.
      required: true
      in: header
      schema:
        type: string
    Status:
      description: Filter by external challenge status.
      in: query
      name: status
      schema:
        enum:
          - PENDING
          - IN_PROGRESS
        type: string
    XRequestId:
      name: X-Request-Id
      in: header
      description: >
        Developer-provided identifier for this request, used for tracing
        requests in Wallets API logs and the Developer Console, and when
        communicating with Circle Support.

        **Must be a UUID to appear in logs.** Non-UUID values are accepted by
        the API but are ignored by logging and tracing systems.
      schema:
        $ref: '#/components/schemas/XRequestId'
  schemas:
    Challenges:
      title: ChallengesResponse
      type: object
      required:
        - data
      properties:
        data:
          type: object
          properties:
            challenges:
              type: array
              items:
                $ref: '#/components/schemas/Challenge'
    XRequestId:
      type: string
      format: uuid
      description: >-
        A unique identifier, which can be helpful for identifying a request when
        communicating with Circle support.
      example: 2adba88e-9d63-44bc-b975-9b6ae3440dde
    Challenge:
      type: object
      required:
        - id
        - type
        - status
      properties:
        id:
          $ref: '#/components/schemas/Id'
        correlationIds:
          type: array
          items:
            type: string
          description: >
            For type CREATE_WALLET, the wallet id associated with the request.
            For types

            CREATE_TRANSACTION, ACCELERATE_TRANSACTION, and CANCEL_TRANSACTION,
            the transaction id associated with the request. 
          example:
            - 54399e5a-1bf6-4921-9559-10c1115678cd
        errorCode:
          description: >-
            Indicates the failure reason of a challenge. Only present for
            challenges in FAILED status.
          example: 155121
          type: integer
        errorMessage:
          description: >-
            Description of the error or error reason. Only present for
            challenges in FAILED status.
          example: challenge expired
          type: string
        status:
          type: string
          enum:
            - PENDING
            - IN_PROGRESS
            - COMPLETE
            - FAILED
            - EXPIRED
          example: PENDING
        type:
          type: string
          enum:
            - ''
            - INITIALIZE
            - SET_PIN
            - CHANGE_PIN
            - SET_SECURITY_QUESTIONS
            - CREATE_WALLET
            - RESTORE_PIN
            - CREATE_TRANSACTION
            - ACCELERATE_TRANSACTION
            - CANCEL_TRANSACTION
            - CONTRACT_EXECUTION
            - WALLET_UPGRADE
            - SIGN_MESSAGE
            - SIGN_TYPEDDATA
            - SIGN_TRANSACTION
          description: The challenge type
          example: SET_PIN
    Id:
      type: string
      format: uuid
      description: System-generated unique identifier of the resource.
      example: c4d1da72-111e-4d52-bdbf-2e74a2d803d5
  headers:
    XRequestId:
      description: >
        Developer-provided header parameter or Circle-generated universally
        unique identifier (UUID v4). Useful for identifying a specific request
        when communicating with Circle Support.
      schema:
        $ref: '#/components/schemas/XRequestId'
  responses:
    BadRequest:
      content:
        application/json:
          schema:
            type: object
            title: BadRequestResponse
            required:
              - code
              - message
            properties:
              code:
                type: integer
                description: Code that corresponds to the error.
              message:
                type: string
                description: Message that describes the error.
            example:
              code: 400
              message: Bad request.
      description: Request cannot be processed due to a client error.
      headers:
        X-Request-Id:
          $ref: '#/components/headers/XRequestId'
    NotAuthorized:
      content:
        application/json:
          schema:
            type: object
            title: NotAuthorizedResponse
            required:
              - code
              - message
            properties:
              code:
                type: integer
                description: Code that corresponds to the error.
              message:
                type: string
                description: Message that describes the error.
            example:
              code: 401
              message: Malformed authorization.
      description: >-
        Request has not been applied because it lacks valid authentication
        credentials.
      headers:
        X-Request-Id:
          $ref: '#/components/headers/XRequestId'
    NotFound:
      content:
        application/json:
          schema:
            type: object
            title: NotFoundResponse
            required:
              - code
              - message
            properties:
              code:
                type: integer
                description: Code that corresponds to the error.
              message:
                type: string
                description: Message that describes the error.
            example:
              code: 404
              message: Not found.
      description: Specified resource was not found.
      headers:
        X-Request-Id:
          $ref: '#/components/headers/XRequestId'
  securitySchemes:
    BearerAuth:
      type: http
      scheme: bearer
      bearerFormat: PREFIX:ID:SECRET
      description: >-
        Circle's API Keys are formatted in the following structure
        "PREFIX:ID:SECRET". All three parts are required to make a successful
        request.

````